; *****************************************************************************
; *****************************************************************************
;
;       File    : Command.Asm
;       Author  : Paul Robson (autismuk@aol.com)
;       Purpose : Handle the Command Line
;       Created : 9th October 1997
;       Modified: 12th November 1997
;
; *****************************************************************************
; *****************************************************************************

.386p 
.model flat
include extern.inc


.data

IsZX80Hardware  db      0               ; Set to 1 if ZX80 Hardware. (-h)
IsZX80Rom       db      0               ; Set to 1 if ZX80 Rom. (-x)
IsVanillaRom    db      0               ; Set to 1 for no hacks built in (-v)
IsRealNMI       db      0               ; Set to 1 for real NMI (-n)
IsAsmROM        db      0               ; Set to 1 if AszMic Rom (-a)
IsNoAccelerate  db      0               ; Set to 1 if no Display Opt (-d)

        align   dword

FileName dd     0                       ; command line filename
Empty    db     0,0,0,0                 ; dummy filename for empty string
.code

SetByte Macro   Char,Flag
        local   @@Skip
        cmp     al,Char
        jne     @@Skip
        mov     [Flag],1
@@Skip:
EndM

CMHandler Proc
        mov     [FileName],offset Empty ; Default File name is an empty string

_CMH0:  cmp     esi,2                   ; check ARGC
        jb      _CMHX

        add     edi,4                   ; eax points to next filename
        mov     ebx,[edi]               ; or command string
        dec     esi

        mov     al,[ebx]                ; look at first character
        cmp     al,'-'                  ; is it a - sign
        je      _CMH1                   ; if so, do it as a control
        mov     [FileName],ebx          ; if not, its a file name
        jmp     _CMH0                   ; do the next one

_CMHX:  ret

_CMH1:  mov     al,[ebx+1]              ; al is the following character
        cmp     al,'a'                  ; make it lower case
        jae     _CMH2
        add     al,32

_CMH2:  SetByte 'h',IsZX80Hardware
        SetByte 'x',IsZX80Rom
        SetByte 'v',IsVanillaRom
        SetByte 'n',IsRealNMI
        SetByte 'a',IsAsmRom
        SetByte 'd',IsNoAccelerate

        cmp     al,'s'                  ; -s boot in normal speed
        jne     _CMH0
        mov     [FrmRate],FrameStd
        jmp     _CMH0


EndP CMHandler

CMFileName Proc
        push    esi
        push    edi
        mov     edi,[FileName]          ; edi = org filename
        mov     esi,offset FNBuffer     ; esi = new filename
FNELoop:mov     dl,[edi]                ; copy until . or \0
        mov     [esi],dl                ; found.
        inc     esi
        inc     edi
        cmp     dl,'.'
        je      FNEDone
        cmp     dl,32
        ja      FNELoop
FNEDone:mov     [esi],eax               ; add new extension
        mov     dl,'.'                  ; add the .
        mov     [esi-1],dl
        mov     ebx,offset FNBuffer     ; ebx points to buffer
        pop     edi
        pop     esi
        ret
.data?
FNBuffer:
        db     127 dup (?)             ; buffer
.code
endP CMFileName

end
