; *****************************************************************************
; *****************************************************************************
;
;       File    : FileIO.Asm
;       Author  : Paul Robson (autismuk@aol.com)
;       Purpose : File I/O Functions
;       Created : 29th September 1997
;       Modified: 9th November 1997
;
;       Functions :
;               FLoad           Load file into memory
;               FSaveMem        Save memory to file
;
; *****************************************************************************
; *****************************************************************************

.386p
.model flat
include extern.inc
.code

; *****************************************************************************
;
;            Load file EDX into Memory, at memory location EBX
;                 return bytes loaded or zero if error
;
; *****************************************************************************

FLoad Proc
        push    ebx                     ; save registers
        push    ecx
        push    edx

        push    ebx                     ; save data address
        mov     al,0                    ; attempt to open file,read only
        mov     ah,03Dh                 ; filename pointer in EDX
        int     21h
        pop     edx                     ; restore address
        jc      _FX1                    ; if failed, return zero.
        push    eax                     ; save handle for close

        mov     ebx,eax                 ; read the file
        mov     ecx,SnapSize            ; try to read in max snapsize...
	mov	ah,03Fh
        int     21h

        pop     ebx                     ; Close the file - restore the handle
        push    eax                     ; eax = bytes read.
	mov	ah,03Eh
        int     21h
        pop     eax                     ; restore bytes read
        jnc     _FX2                    ; if no carry, passed ok.
_FX1:   xor     eax,eax                 ; return zero
_FX2:   pop     edx
        pop     ecx
        pop     ebx
        ret

endp FLoad

; ***********************************************************************
; *                                                                     *
; *          Save file name EDX from memory at EAX size ECX             *
; *                                                                     *
; ***********************************************************************

FSaveMem Proc
        push    eax ebx ecx edx                         ; save everything
        push    eax ecx                                 ; save start & size
        push    edx                                     ; save filename
        mov     ah,41h                                  ; delete file
        int     21h
        pop     edx                                     ; edx = filename
        xor     cx,cx                                   ; cx = attribute
        mov     ah,3Ch
        int     21h                                     ; create the file
        pop     ecx                                     ; restore size
        pop     edx                                     ; restore address
        push    eax                                     ; save handle
        mov     bx,ax                                   ; put in bx
        mov     ah,40h                                  ; and write
        int     21h
        pop     ebx                                     ; restore handle
        mov     ah,3Eh                                  ; close file
        int     21h
        pop     edx ecx ebx eax
        ret

EndP FSaveMem

end
